#include <iostream.h>
#include <fstream.h>
#include <list.h>
#include <algo.h>

// Add SnapPea

#include "kernel.h"

// from limit_utils.cc

extern void print_complex(Complex z);
extern void print_mt(MoebiusTransformation* M);
extern void gens_of_gieseking_manifold(MoebiusTransformation* U,
				MoebiusTransformation* V);
extern void fiber_generators(MoebiusTransformation* generators, int* dir_entered);
extern void fiber_section_generators(MoebiusTransformation* generators, int* dir_entered);
extern void other_section_generators(MoebiusTransformation* generators, int* dir_entered);
extern Complex apply_mt_to_bdry(MoebiusTransformation* T, Complex z);

// Various std complex numbers from complex.c

extern Complex Zero;
extern Complex One;
extern Complex Two;
extern Complex Four;
extern Complex MinusOne;
extern Complex I;
extern Complex TwoPi;
extern Complex Infinity;

// Point Record

class PointRecord
{
 public:
  MoebiusTransformation   group_elt;
  Complex                 z;
  int                     dir_entered;
  bool                    is_new;
  
  PointRecord(MoebiusTransformation* M, Complex given_point, int direction){
    Moebius_copy(&group_elt, M);
    z = given_point;
    dir_entered = direction;
    is_new = true;
  }

  bool operator<(const PointRecord& other_point){
    if (z.real == other_point.z.real)
      return z.imag < other_point.z.imag;
    else
      return z.real < other_point.z.real;
  }

};



