// extern void compute_fourth_corner(
//        Complex                 corner[4],
//        VertexIndex             missing_corner,
//        Orientation             orientation,
//        ComplexWithLog  cwl[3]);

extern void initial_corners(Tetrahedron *tet, Boolean centroid_at_origin);
extern void create_normal_surface_script(Triangulation   *manifold);

%inline %{

Complex develop_fourth_corner(Complex* c0, Complex* c1, Complex* c2, Complex* c3, 
     int missing_corner, Triangulation* manifold,  int tet_number){
	Complex corner[4];
	int i;
	Tetrahedron* tet;
	corner[0] = *c0;
	corner[1] = *c1;	
	corner[2] = *c2;	
	corner[3] = *c3;	

	tet = manifold->tet_list_begin.next;
	for (i = 0; i < tet_number; i++)
		tet = tet->next;
	
	compute_fourth_corner(corner, missing_corner, right_handed, tet->shape[filled]->cwl[ultimate]);
	return corner[missing_corner];
};
%}


%apply Complex* OUTPUT {Complex* r0, Complex* r1, Complex* r2, Complex* r3};
%inline %{

void find_initial_corners(Complex* r0, Complex* r1, Complex* r2, Complex* r3,
	Triangulation* manifold, int tet_number){
	int i;
	Tetrahedron* tet;

	tet = manifold->tet_list_begin.next;
	for (i = 0; i < tet_number; i++)
		tet = tet->next;

	
	initial_corners(tet, TRUE);
	*r0 = tet->corner[0];
	*r1 = tet->corner[1];
	*r2 = tet->corner[2];
	*r3 = tet->corner[3];
};
		
%}

%inline%{
  void what_the_bleep(void){
    Triangulation* M;
    int n;
    DualOneSkeletonCurve** curves;
    M = get_triangulation("bad_drilling");
    dual_curves(M, 6, &n, &curves);
    printf("bad_drilling: %i\n", n);
    M = get_triangulation("good_drilling");
    dual_curves(M, 6, &n, &curves);
    printf("good_drilling: %i\n", n);
  };
  %}

    
