#  semifibered.py

from SnapPea import *

def check_if_definately_not_fibered_or_semifibered(manifold):
    if manifold.first_betti() > 0:     #check if fibered
        return 0
    if manifold.first_betti(2) >= 2:     # check if semi-fibered
        for cover in manifold.covers(2):   
            if cover.first_betti() > 0:
                return 0
    return 1        

def main():
    for manifold in orientable_closed_manifolds():
        if not check_if_definately_not_fibered_or_semifibered(manifold):
            print manifold, manifold.volume(), homology(manifold), "may be (semi)-fibered"

main()

#---- program ouput -------
#
# m140(4,1) 2.66674478345 Z/2 + Z/10 may be (semi)-fibered
# m188(2,3) 3.04482481923 Z/2 + Z/26 may be (semi)-fibered
# m160(3,1) 3.16633332125 Z/3 + Z may be (semi)-fibered
# m159(4,1) 3.16633332125 Z/7 + Z may be (semi)-fibered
# m188(4,1) 3.1772932786 Z/2 + Z/32 may be (semi)-fibered
# etc.
        
