from distutils.core import setup, Extension
from  glob  import glob
import os

# first setup paths


paths_file_contents =  """
# AUTOGENERATED, DO NOT MODIFY
base_path = "BASE"

manifold_directory = base_path + "manifolds"
trs_directory = base_path + "census_manifolds"
closed_manifold_directory = base_path + "census_manifolds"
"""

paths_file_contents = paths_file_contents.replace("BASE", os.getcwd()[:-4])
f = open("paths.py", "w")
f.write(paths_file_contents)
f.close()


extras = glob("../snappea_source/*.o") + glob("../modified_snappea_source/*.o")



module1 = Extension('SnapPeac',
                    sources = ['SnapPea_wrap.cc'], include_dirs = ["../snappea_source", "../modified_snappea_source"], extra_objects = extras)

setup (name = 'SnapPeac',
       version = '',
       description = "Nathan's broken interface to SnapPea",
       ext_modules = [module1])


os.system("mv build/lib.*/SnapPeac* .")
